Foxit PDF RDK

Static Public Member Functions | List of all members
Library Class Reference
Inheritance diagram for Library:

## Static Public Member Functions
static | EnableJavaScript (enable_javascript)
| Enable or disable javascript for PDF. More...
static | EnableThreadSafety (is_enable_thread_safety)
| Enable thread safety. More...
static | GetRenderConfig ()
| Get the rendering configuration. More...
static | GetVersion ()
| Get the version of current Foxit PDF SDK library. More...
static | HasModuleLicenseRight (module_name)
| Check if user has right to use a specified module of Foxit PDF SDK in current used license information (which is used to initialize Foxit PDF SDK). More...
static | Initialize (sn, key)
| Initialize Foxit PDF SDK Library, with valid license information. More...
static | InitializeOFDEngine (ofd_library_path)
| Initialize OFD engine. More...
static | RegisterSecurityCallback (filter, callback)
| Register a SecurityCallback object to Foxit PDF SDK for decryption of the PDFs with special encryption filters. More...
static | RegisterSignatureCallback (filter, sub_filter, signature_callback)
| Register a third-party SignatureCallback object to Foxit PDF SDK for signing and verifying signature, along with the filter and sub filter name of the callback. More...
static | RegisterXFAAppProviderCallback (callback)
| Register an AppProviderCallback object to Foxit PDF SDK. More...
static | Reinitialize ()
| Re-initialize Foxit PDF SDK Library. More...
static | Release ()
| Release all resource allocated by Foxit PDF SDK Library. More...
static | ReleaseOFDEngine ()
| Release OFD engine. More...
static | SetActionCallback (action_callback)
| Set a ActionCallback object to Foxit PDF SDK, in aid of performing PDF actions. More...
static | SetAnnotIconProviderCallback (annot_icon_provider)
| Set a customized IconProviderCallback object to Foxit PDF SDK. More...
static | SetCacheSize (size)
| Set the upper limit of PDF library cache size. More...
static | SetDefaultICCProfilesPath (icc_profile_folder_path)
| Set path of folder which contains default ICC profile files. More...
static | SetDocEventCallback (callback)
| Set a DocEventCallback object to Foxit PDF SDK. More...
static | SetFontMapperCallback (callback)
| Set a FontMapperCallback object to Foxit PDF SDK. More...
static | SetLogFile (log_file_path)
| Set the log file path. More...
static | SetLogFile (log_file_path)
| Set the log file path. More...
static | SetNotifierCallback (notifier)
| Set a NotifierCallback object to Foxit PDF SDK. More...
static | SetRenderConfig (render_config)
| Set the rendering configuration. More...
static | SetRenderTextGamma (gamma)
| Set gamma value for text rendering. More...
static | SetTimeStampCallback (timestamp_callback)
| Set a TimeStampCallback object to Foxit PDF SDK, in aid of interacting with time stamp server. More...
static | UnregisterSecurityCallback (filter)
| Unregister a SecurityCallback object from Foxit PDF SDK. More...

## Additional Inherited Members
Public Member Functions inherited from NativeObjectWrapper
| constructor (r)
| GetPointerAsNumber ()

## Detailed Description

This class represents the library management. It contains functions to initialize/re-initialize/release Foxit PDF SDK library, and also contains functions for global use.
Any application should load Foxit PDF SDK by function Library.Initialize before calling any other Foxit PDF SDK functions. When there is no need to use Foxit PDF SDK any more, please call function Library.Release.
Functions in Foxit PDF SDK may throw exception when some error occurs. User can catch these exceptions and check the error code with values starting from e_ErrFile to know more about what error occurs.

Note
  During the life-cycle of an application, Library.Initialize and Library.Release should be called in pair and can only be called once. Once Library.Release is called during the life-cycle of an application, Foxit PDF SDK cannot be initialized any more in the life-cycle of the application. Before Library.Release is called, if user wants to re-initialize Foxit PDF SDK, please refer to function Library.Reinitialize.

Examples
  /Users/ec2-user/gitlab-runner/builds/E-xKdhDo/0/foxit/sdk/mobile/gsdk-doc-auto-build/harmony_nodejs/input/Index.js.

## Member Function Documentation

## ◆ EnableJavaScript()

static Library.EnableJavaScript | ( | enable_javascript |  | ) |
| static

Enable or disable javascript for PDF.

Javascript for PDF is enabled by default.

Parameters

  [in] | enable_javascript | true means to enable javascript, and false means to disable javascript. If this function is not called, javascript for PDF is enabled by default.

Returns
  true means success, while false means failure.

## ◆ EnableThreadSafety()

static Library.EnableThreadSafety | ( | is_enable_thread_safety |  | ) |
| static

Enable thread safety.

Currently, module "OCR" does not support thread safety.

Parameters

  [in] | is_enable_thread_safety | Enable thread safety.true means to enable thread safety, while false means to disable thread safety.

Returns
  None.

## ◆ GetRenderConfig()

static Library.GetRenderConfig | ( |  | ) |
| static

Get the rendering configuration.

Returns
  A rendering configuration object which shows current configuration.

## ◆ GetVersion()

static Library.GetVersion | ( |  | ) |
| static

Get the version of current Foxit PDF SDK library.

Returns
  Version string.

## ◆ HasModuleLicenseRight()

static Library.HasModuleLicenseRight | ( | module_name |  | ) |
| static

Check if user has right to use a specified module of Foxit PDF SDK in current used license information (which is used to initialize Foxit PDF SDK).

In Foxit PDF SDK, once the library is initialized successfully, most feature can be used. But for some special features, they can be used only when specified modules are defined in license information. This function can be used to check if user has right for these special modules before using these feature.

Parameters

  [in] | module_name | Name of the module whose right is to be checked. Please refer to values starting from e_ModuleNameConnectedPDF and this should be one of these values.

Returns
  true means user has right to use the specified module, while false means user does not have right to use the specified module.

## ◆ Initialize()

static Library.Initialize | ( | sn | ,
|  | key |
| ) |  |
| static

Initialize Foxit PDF SDK Library, with valid license information.

During the life-cycle of an application, this function can only be called once and should be called first before any other functions in Foxit PDF SDK can be called.
Once function Library.Release is called, Foxit PDF SDK library cannot be initialized any more in the life-cycle of the application.

Parameters

  [in] | sn | String of sn information, which can be retrieved from "SN=" part in key file "gsdk_sn.txt" or "rdk_sn.txt".
  [in] | key | String of key information, which can be retrieved from "Sign=" part in key file "gsdk_key.txt" or "rdk_key.txt".

Returns
  e_ErrSuccess means success.
  e_ErrInvalidLicense means input license information is invalid.
  e_ErrParam means parameter sn or key is an empty string.
  For more information about error code values, please refer to values starting from e_ErrSuccess.

## ◆ InitializeOFDEngine()

static Library.InitializeOFDEngine | ( | ofd_library_path |  | ) |
| static

Initialize OFD engine.

This function must be called before using any other functions in OFD module. Before using OFD module, please ensure the resource folders named "lib" in the OFD package is valid. Before initializing OFD engine and using any classes or methods in this module, please ensure Foxti PDF SDK has been initialized successfully by function Library.Initialize with a key including "OFD" module.
Currently, OFD module only supports Windows and Linux64 system.

Parameters

  [in] | ofd_library_path | Path of OFD library. This should not be an empty string.

Returns
  e_ErrSuccess means success.
  For more information about error code values, please refer to values starting from e_ErrSuccess.

## ◆ RegisterSecurityCallback()

static Library.RegisterSecurityCallback | ( | filter | ,
|  | callback |
| ) |  |
| static

Register a SecurityCallback object to Foxit PDF SDK for decryption of the PDFs with special encryption filters.

When this function is successful, Foxit PDF SDK will take over the input security callback object and user should not release this callback object directly anymore; otherwise unexpected crash may occurs later.
Foxit PDF SDK may release the security callback object by callback function SecurityCallback.Release, when unregister it and find that it has not been used by other object. So, user is recommended not to use the security callback object any more after function Library.UnregisterSecurityCallback.

Parameters

  [in] | filter | The filter name of the security callback object. This should not be null or an empty string. When users implement security callback of CustomSecurityCallback, users could specified their own custom filter string, but need to follow the PDF name conventions. When users implement security callback of CertificateSecurityCallback, the filter value must be set to "Adobe.PubSec". When users implement security callback of DRMSecurityCallback, the filter value must be set to "FoxitDRM", or some error may occur later. When users implement security callback of RMSSecurityCallback, the filter value must be set to "MicrosoftIRMServices" or "FoxitRMS", or some error may occur later.
  [in] | callback | A SecurityCallback object, which is implemented by user and based on callback class SecurityCallback. User should not inherit SecurityCallback directly, but inherit its derived class, such as CustomSecurityCallback, CertificateSecurityCallback, etc.

Returns
  true means success, while false means failure.

Note
  If module "RMS" is not defined in the license information which is used in function Library.Initialize, that means user has no right in using RMS related functions and this function will throw exception e_ErrNoRMSModuleRight.

## ◆ RegisterSignatureCallback()

static Library.RegisterSignatureCallback | ( | filter | ,
|  | sub_filter | ,
|  | signature_callback |
| ) |  |
| static

Register a third-party SignatureCallback object to Foxit PDF SDK for signing and verifying signature, along with the filter and sub filter name of the callback.

Foxit PDF SDK has default signature callbacks defined with filter and sub filter:

- filter: "Adobe.PPKLite" and sub filter: "adbe.pkcs7.detached"
- filter: "Adobe.PPKLite" and sub filter: "adbe.pkcs7.sha1"
- filter: "Adobe.PPKLite" and sub filter: "ETSI.CAdES.detached"
- filter: "Adobe.PPKLite" and sub filter: "ETSI.RFC3161"

If user wants to use a third-party signature callback, please call this function before signing or verifying signature process.
If user register a customized signature callback with the same filter and sub filter as default ones by this function, and the value of parameter signature_callback is not null, the default signature callback in Foxit PDF SDK will not have effect. If user register a customized signature callback with the same filter and sub filter as default ones by this function, and the value of parameter signature_callback is null, the default signature callback in Foxit PDF SDK will have effect again.

Parameters

  [in] | filter | The filter name of the signature callback, in ASCII encoding. This should not be an empty string. Filter name is the name of the signature callback.
  [in] | sub_filter | The sub filter name of the signature callback, in ASCII encoding. Sub filter is to describe the encoding of signature value and key information in the signature dictionary.
  [in] | signature_callback | A customized SignatureCallback object, which is implemented by user and based on callback class SignatureCallback. User should ensure all the callback functions have been implemented in application level and should also ensure this signature callback object valid until Foxit PDF SDK is released by function Library.Release. If this is null, that means the registered third-party callback is to be removed from Foxit PDF SDK.

Returns
  true means success, while false means failure.

## ◆ RegisterXFAAppProviderCallback()

static Library.RegisterXFAAppProviderCallback | ( | callback |  | ) |
| static

Register an AppProviderCallback object to Foxit PDF SDK.

This function should be called first before processing XFA document.

Parameters

  [in] | callback | An AppProviderCallback object, which is implemented by user and based on callback class AppProviderCallback. User should ensure all the callback functions have been implemented in application level and should also ensure this XFA application provider callback object valid until Foxit PDF SDK is released by function Library.Release.

Returns
  None.

Note
  If module "XFA" is not defined in the license information which is used in function Library.Initialize, that means user has no right in using XFA related functions and this function will throw exception e_ErrNoXFAModuleRight.

## ◆ Reinitialize()

static Library.Reinitialize | ( |  | ) |
| static

Re-initialize Foxit PDF SDK Library.

When user meets out-of-memory error or user wants to re-initialize Foxit PDF SDK library before function Library.Release is called, user can call this function to re-initialize Foxit PDF SDK Library.
Once function Library.Release is called, Foxit PDF SDK library cannot be initialized any more in the life-cycle of the application.

Returns
  e_ErrSuccess means success. For more information about error code values, please refer to values starting from e_ErrSuccess.

## ◆ Release()

static Library.Release | ( |  | ) |
| static

Release all resource allocated by Foxit PDF SDK Library.

User should call this function to release all memory blocks allocated by the library.
Once this fucntion is called, Foxit PDF SDK library cannot be initialized any more in the life-cycle of the application.

Returns
  None.

## ◆ ReleaseOFDEngine()

static Library.ReleaseOFDEngine | ( |  | ) |
| static

Release OFD engine.

This function can be called to release OFD engine when no need to use it any more before Foxit PDF SDK is released.

Returns
  None.

## ◆ SetActionCallback()

static Library.SetActionCallback | ( | action_callback |  | ) |
| static

Set a ActionCallback object to Foxit PDF SDK, in aid of performing PDF actions.

User should implement an action callback object and call this function to set the action callback object to Foxit PDF SDK if PDF actions need to be performed, such as filling a PDF form.

Parameters

  [in] | action_callback | A customized ActionCallback object. null means not use any action callback object. User should ensure all the callback functions have been implemented in application level. If this is a valid action callback object, Foxit PDF SDK will take over the management of this callback object and user should not release it directly.

Returns
  true means success, while false means failure.

## ◆ SetAnnotIconProviderCallback()

static Library.SetAnnotIconProviderCallback | ( | annot_icon_provider |  | ) |
| static

Set a customized IconProviderCallback object to Foxit PDF SDK.

User can call this function to set a customized icon provider for annotation. If this function has been called several times, Foxit PDF SDK will only keep the last icon provider. If this function has not been called even once, Foxit PDF SDK will use the default standard icon provider.

Parameters

  [in] | annot_icon_provider | A customized annotation icon provider, which is implemented based on callback class IconProviderCallback. If this is null, customized annotation icon provider will be removed from Foxit PDF SDK and default standard icon provider will be used instead. Application should ensure this icon provider object valid until it has been removed from Foxit PDF SDK or function Library.Release is called.

Returns
  true means success, while false means failure.

Note
  Icon provider's ID and version are treated as the name of the icon provider, so please offer different "ID + version" for different icon providers by callback functions IconProviderCallback.GetProviderID and IconProviderCallback.GetProviderVersion.

## ◆ SetCacheSize()

static Library.SetCacheSize | ( | size |  | ) |
| static

Set the upper limit of PDF library cache size.

If no cache size limit is set by application, the cache size will be set to 200 MegaBytes internally by default.

Parameters

  [in] | size | The upper limit of the cache, in MegaBytes, 0~4096. If set to 0, that means not to use limit of cache size.

Returns
  true means success, while false means failure.

## ◆ SetDefaultICCProfilesPath()

static Library.SetDefaultICCProfilesPath | ( | icc_profile_folder_path |  | ) |
| static

Set path of folder which contains default ICC profile files.

Default ICC profile files are offered in "res" folder Foxit PDF SDK package. Default ICC profile files are "sRGB Color Space Profile.icm", "sGray.icc", and "USWebCoatedSWOP.icc". Foxit PDF SDK will load these default ICC profile files from input folder path.
If input folder path does not exist or default ICC profile files are not all in the specified folder, this function will throw e_ErrFilePathNotExist.

Parameters

  [in] | icc_profile_folder_path | A valid path of a folder which contains default ICC profile files.

Returns
  None.

## ◆ SetDocEventCallback()

static Library.SetDocEventCallback | ( | callback |  | ) |
| static

Set a DocEventCallback object to Foxit PDF SDK.

Parameters

  [in] | callback | A DocEventCallback object. null means not use any document event callback object.

Returns
  true means success, while false means failure.

## ◆ SetFontMapperCallback()

static Library.SetFontMapperCallback | ( | callback |  | ) |
| static

Set a FontMapperCallback object to Foxit PDF SDK.

Once a valid custom font mapper callback is set to Foxit PDF SDK, Foxit PDF SDK will first use this callback when mapping a font.

Parameters

  [in] | callback | A FontMapperCallback object. null means not use any custom font mapper callback object.

Returns
  true means success, while false means failure.

## ◆ SetLogFile() [1/2]

static Library.SetLogFile | ( | log_file_path |  | ) |
| static

Set the log file path.

After a log file path is set to Foxit PDF SDK, all the logs will be written to the log file. Currently, the log information in Foxit PDF SDK is simple; this will be improved in future version.

Parameters

  [in] | log_file_path | A log file path.

Returns
  None.

## ◆ SetLogFile() [2/2]

static Library.SetLogFile | ( | log_file_path |  | ) |
| static

Set the log file path.

After a log file path is set to Foxit PDF SDK, all the logs will be written to the log file. Currently, the log information in Foxit PDF SDK is simple; this will be improved in future version.

Parameters

  [in] | log_file_path | A log file path.

Returns
  None.

## ◆ SetNotifierCallback()

static Library.SetNotifierCallback | ( | notifier |  | ) |
| static

Set a NotifierCallback object to Foxit PDF SDK.

User can call this function to set a notifier callback object to Foxit PDF SDK, so that when events (such as OOM) happens, user would be notified.

Parameters

  [in] | notifier | A NotifierCallback object. User should ensure all the callback functions have been implemented in application level.

Returns
  true means success, while false means failure.

## ◆ SetRenderConfig()

static Library.SetRenderConfig | ( | render_config |  | ) |
| static

Set the rendering configuration.

Parameters

  [in] | render_config | A rendering configuration object to be set.

Returns
  None.

## ◆ SetRenderTextGamma()

static Library.SetRenderTextGamma | ( | gamma |  | ) |
| static

Set gamma value for text rendering.

If this function is not called to set gamma value, Foxit PDF SDK will use 2.2 as the default value.

Parameters

  [in] | gamma | Gamma value. It should be greater than 0.

Returns
  None.

## ◆ SetTimeStampCallback()

static Library.SetTimeStampCallback | ( | timestamp_callback |  | ) |
| static

Set a TimeStampCallback object to Foxit PDF SDK, in aid of interacting with time stamp server.

When this function is successful, Foxit PDF SDK will take over the default time stamp interaction during signing and user should not release this callback object directly anymore; otherwise unexpected crash may occurs later.
Foxit PDF SDK may release the time stamp callback object by callback function TimeStampCallback.Release, when timestamp_callback is null.

Parameters

  [in] | timestamp_callback | A customized TimeStampCallback object, which is implemented by user and based on callback class TimeStampCallback. User should ensure all the callback functions have been implemented in application level and should also ensure this time stamp callback object valid until Foxit PDF SDK is released by function Library.Release. If this is null, that means the registered third-party callback is to be removed from Foxit PDF SDK.

Returns
  true means success, while false means failure.

## ◆ UnregisterSecurityCallback()

static Library.UnregisterSecurityCallback | ( | filter |  | ) |
| static

Unregister a SecurityCallback object from Foxit PDF SDK.

Foxit PDF SDK may release the security callback function by callback function SecurityCallback.Release, when unregister it and find that it has not been used by other object. So, user is recommended not to use the security callback object any more after function Library.UnregisterSecurityCallback.

Parameters

  [in] | filter | The filter name which is used for registering a security callback object. Please refer to comment of parameter filter in function Library.RegisterSecurityCallback.

Returns
  true means success, while false means failure.

Note
  If module "RMS" is not defined in the license information which is used in function Library.Initialize, that means user has no right in using RMS related functions and this function will throw exception e_ErrNoRMSModuleRight.